- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# MetaElement Class Reference
[Fundamental C++: the Element design pattern.]

Parent class of Element. More...

Inheritance diagram for MetaElement:

[legend]

## Detailed Description

Parent class of Element.

MetaElement provides most of the services of Element. It has three roles:

- specify the interface of `Element<S, T>`,
- offer additional abstract services implemented using only services in the specified interfaces,
- link services to their external implementations.

Of course this class must be specialized over S and T, and no generic implementation is provided.

For additional genericity, the hierarchy between concepts should be mapped to a hierarchy of between their specialization of `MetaElement`.

See also:
  - `Element`
  - MetaElement< Structure<S>, T>